<html>
<head>
<title>OGRE: OgreSceneManagerEnumerator.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreSceneManagerEnumerator.h</h1><a href="OgreSceneManagerEnumerator_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __SceneManagerEnumerator_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __SceneManagerEnumerator_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreSceneManager_8h.html">OgreSceneManager.h</a>"</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreSingleton_8h.html">OgreSingleton.h</a>"</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include "<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>"</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039     
<a name="l00041"></a><a class="code" href="classOgre_1_1DefaultSceneManagerFactory.html">00041</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1DefaultSceneManagerFactory.html" title="Factory for default scene manager.">DefaultSceneManagerFactory</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SceneManagerFactory.html" title="Class which will create instances of a given SceneManager.">SceneManagerFactory</a>
<a name="l00042"></a>00042     {
<a name="l00043"></a>00043     <span class="keyword">protected</span>:
<a name="l00044"></a>00044         <span class="keywordtype">void</span> initMetaData(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00045"></a>00045     <span class="keyword">public</span>:
<a name="l00046"></a><a class="code" href="classOgre_1_1DefaultSceneManagerFactory.html#ffd69f67c70d61231b323b1de67af92f">00046</a>         <a class="code" href="classOgre_1_1DefaultSceneManagerFactory.html" title="Factory for default scene manager.">DefaultSceneManagerFactory</a>() {}
<a name="l00047"></a><a class="code" href="classOgre_1_1DefaultSceneManagerFactory.html#87932aa032f993f51292da737f5e83f3">00047</a>         ~<a class="code" href="classOgre_1_1DefaultSceneManagerFactory.html" title="Factory for default scene manager.">DefaultSceneManagerFactory</a>() {}
<a name="l00049"></a><a class="code" href="classOgre_1_1DefaultSceneManagerFactory.html#ecb930d0603388f00979d9822a24d7bf">00049</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> FACTORY_TYPE_NAME;
<a name="l00050"></a>00050         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>* createInstance(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; instanceName);
<a name="l00051"></a>00051         <span class="keywordtype">void</span> destroyInstance(<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>* instance);
<a name="l00052"></a>00052     };
<a name="l00054"></a><a class="code" href="classOgre_1_1DefaultSceneManager.html">00054</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1DefaultSceneManager.html" title="Default scene manager.">DefaultSceneManager</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>
<a name="l00055"></a>00055     {
<a name="l00056"></a>00056     <span class="keyword">public</span>:
<a name="l00057"></a>00057         <a class="code" href="classOgre_1_1DefaultSceneManager.html" title="Default scene manager.">DefaultSceneManager</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00058"></a>00058         ~<a class="code" href="classOgre_1_1DefaultSceneManager.html" title="Default scene manager.">DefaultSceneManager</a>();
<a name="l00059"></a>00059         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getTypeName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00060"></a>00060     };
<a name="l00061"></a>00061 
<a name="l00082"></a><a class="code" href="classOgre_1_1SceneManagerEnumerator.html">00082</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1SceneManagerEnumerator.html" title="Enumerates the SceneManager classes available to applications.">SceneManagerEnumerator</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>&lt;SceneManagerEnumerator&gt;
<a name="l00083"></a>00083     {
<a name="l00084"></a>00084     <span class="keyword">public</span>:
<a name="l00086"></a><a class="code" href="classOgre_1_1SceneManagerEnumerator.html#b97d2f08984d72f3feca11b4ade4c252">00086</a>         <span class="keyword">typedef</span> std::map&lt;String, SceneManager*&gt; Instances;
<a name="l00088"></a><a class="code" href="classOgre_1_1SceneManagerEnumerator.html#2f7852dbcd5c15830c2610c823fdefdb">00088</a>         <span class="keyword">typedef</span> std::vector&lt;const SceneManagerMetaData*&gt; MetaDataList;
<a name="l00089"></a>00089     <span class="keyword">private</span>:
<a name="l00091"></a><a class="code" href="classOgre_1_1SceneManagerEnumerator.html#14fdb5ced550f83875c3a04747aa90bd">00091</a>         <span class="keyword">typedef</span> std::list&lt;SceneManagerFactory*&gt; Factories;
<a name="l00092"></a><a class="code" href="classOgre_1_1SceneManagerEnumerator.html#b1a2d0123b64f95a29460d176b36d971">00092</a>         Factories mFactories;
<a name="l00093"></a><a class="code" href="classOgre_1_1SceneManagerEnumerator.html#94dbb182944a32cf82137b253351d8ee">00093</a>         Instances mInstances;
<a name="l00095"></a><a class="code" href="classOgre_1_1SceneManagerEnumerator.html#966292fbcb304e584f411075f95cf5b2">00095</a>         MetaDataList mMetaDataList;
<a name="l00097"></a><a class="code" href="classOgre_1_1SceneManagerEnumerator.html#6246f52d458fd225d38ac5341ea0385e">00097</a>         <a class="code" href="classOgre_1_1DefaultSceneManagerFactory.html" title="Factory for default scene manager.">DefaultSceneManagerFactory</a> mDefaultFactory;
<a name="l00099"></a><a class="code" href="classOgre_1_1SceneManagerEnumerator.html#7742ef989061d92dc8ad9a5c12dedc7e">00099</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> mInstanceCreateCount;
<a name="l00101"></a><a class="code" href="classOgre_1_1SceneManagerEnumerator.html#3cc008e5a1a0c9cdb40ea466edde6f34">00101</a>         <a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a>* mCurrentRenderSystem;
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a>00104     <span class="keyword">public</span>:
<a name="l00105"></a>00105         <a class="code" href="classOgre_1_1SceneManagerEnumerator.html" title="Enumerates the SceneManager classes available to applications.">SceneManagerEnumerator</a>();
<a name="l00106"></a>00106         ~<a class="code" href="classOgre_1_1SceneManagerEnumerator.html" title="Enumerates the SceneManager classes available to applications.">SceneManagerEnumerator</a>();
<a name="l00107"></a>00107 
<a name="l00112"></a>00112         <span class="keywordtype">void</span> addFactory(<a class="code" href="classOgre_1_1SceneManagerFactory.html" title="Class which will create instances of a given SceneManager.">SceneManagerFactory</a>* fact);
<a name="l00113"></a>00113 
<a name="l00116"></a>00116         <span class="keywordtype">void</span> removeFactory(<a class="code" href="classOgre_1_1SceneManagerFactory.html" title="Class which will create instances of a given SceneManager.">SceneManagerFactory</a>* fact);
<a name="l00117"></a>00117 
<a name="l00127"></a>00127         <span class="keyword">const</span> <a class="code" href="structOgre_1_1SceneManagerMetaData.html" title="Structure containing information about a scene manager.">SceneManagerMetaData</a>* getMetaData(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; typeName) <span class="keyword">const</span>;
<a name="l00128"></a>00128 
<a name="l00129"></a><a class="code" href="classOgre_1_1SceneManagerEnumerator.html#ba1ede3f8195a234c286f372ef181ce0">00129</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Wraps iteration over a const vector.">ConstVectorIterator&lt;MetaDataList&gt;</a> <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Wraps iteration over a const vector.">MetaDataIterator</a>;
<a name="l00133"></a>00133         <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Wraps iteration over a const vector.">MetaDataIterator</a> getMetaDataIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00134"></a>00134 
<a name="l00146"></a>00146         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>* createSceneManager(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; typeName, 
<a name="l00147"></a>00147             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; instanceName = <a class="code" href="classOgre_1_1StringUtil.html#d2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00148"></a>00148 
<a name="l00161"></a>00161         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>* createSceneManager(<a class="code" href="namespaceOgre.html#a4b6dbd7bf722582a21fcc25d25f73ed" title="Bitmask containing scene types.">SceneTypeMask</a> typeMask, 
<a name="l00162"></a>00162             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; instanceName = <a class="code" href="classOgre_1_1StringUtil.html#d2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00163"></a>00163 
<a name="l00165"></a>00165         <span class="keywordtype">void</span> destroySceneManager(<a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>* sm);
<a name="l00166"></a>00166 
<a name="l00171"></a>00171         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>* getSceneManager(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; instanceName) <span class="keyword">const</span>;
<a name="l00172"></a>00172 
<a name="l00173"></a><a class="code" href="classOgre_1_1SceneManagerEnumerator.html#d27d358bd89b7b44a8b360ce36df3aaa">00173</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">MapIterator&lt;Instances&gt;</a> <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">SceneManagerIterator</a>;
<a name="l00175"></a>00175         <a class="code" href="classOgre_1_1MapIterator.html" title="Wraps iteration over a map.">SceneManagerIterator</a> getSceneManagerIterator(<span class="keywordtype">void</span>);
<a name="l00176"></a>00176 
<a name="l00179"></a>00179         <span class="keywordtype">void</span> setRenderSystem(<a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a>* rs);
<a name="l00180"></a>00180 
<a name="l00182"></a>00182         <span class="keywordtype">void</span> shutdownAll(<span class="keywordtype">void</span>);
<a name="l00198"></a>00198         <span class="keyword">static</span> <a class="code" href="classOgre_1_1SceneManagerEnumerator.html" title="Enumerates the SceneManager classes available to applications.">SceneManagerEnumerator</a>&amp; getSingleton(<span class="keywordtype">void</span>);
<a name="l00214"></a>00214         <span class="keyword">static</span> <a class="code" href="classOgre_1_1SceneManagerEnumerator.html" title="Enumerates the SceneManager classes available to applications.">SceneManagerEnumerator</a>* getSingletonPtr(<span class="keywordtype">void</span>);
<a name="l00215"></a>00215 
<a name="l00216"></a>00216     };
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 }
<a name="l00220"></a>00220 
<a name="l00221"></a>00221 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:55 2008
</p>
</body>
</html>
